Use UUID-based mounts for create and import
[ext/instance-debootstrap.git] / import
1 #!/bin/sh
2
3 # Copyright (C) 2007 Google Inc.
4 #
5 # This program is free software; you can redistribute it and/or modify
6 # it under the terms of the GNU General Public License as published by
7 # the Free Software Foundation; either version 2 of the License, or
8 # (at your option) any later version.
9 #
10 # This program is distributed in the hope that it will be useful, but
11 # WITHOUT ANY WARRANTY; without even the implied warranty of
12 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
13 # General Public License for more details.
14 #
15 # You should have received a copy of the GNU General Public License
16 # along with this program; if not, write to the Free Software
17 # Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
18 # 02110-1301, USA.
19
20 set -e
21
22 TEMP=`getopt -o i:b:s: -n '$0' -- "$@"`
23
24 if [ $? != 0 ] ; then echo "Terminating..." >&2 ; exit 1 ; fi
25
26 # Note the quotes around `$TEMP': they are essential!
27 eval set -- "$TEMP"
28
29 while true; do 
30         case "$1" in
31                 -i) instance=$2; shift 2;;
32
33                 -b) blockdev=$2; shift 2;;
34
35                 -s) swapdev=$2; shift 2;;
36
37                 --) shift; break;;
38
39                 *)  echo "Internal error!"; exit 1;;
40         esac
41 done
42 if [ -z "$instance" -o -z "$blockdev" -o -z "$swapdev" ]; then
43         echo "Missing -i or -b or -s argument!"
44         exit 1
45 fi
46
47 swap_uuid=$(mkswap $swapdev | grep 'UUID' | sed -re 's/.*UUID=//')
48 mke2fs -Fjq $blockdev
49 root_uuid=$(dumpe2fs -h $blockdev | grep '^Filesystem UUID:' \
50             | sed -re 's/.*UUID:\s*//')
51
52 TMPDIR=`mktemp -d` || exit 1
53 trap "umount $TMPDIR; rmdir $TMPDIR" EXIT
54
55 # If it's not a block device try to mount it via loopback device.
56 # This is needed for file disks.
57 MOUNT_OPTIONS=""
58 if [ ! -b $blockdev ]; then
59   MOUNT_OPTIONS="$MOUNT_OPTIONS -o loop"
60 fi
61 mount $MOUNT_OPTIONS $blockdev $TMPDIR
62
63 ( cd $TMPDIR; restore -r -y -f - )
64 rm -f $TMPDIR/etc/udev/rules.d/z25_persistent-net.rules
65
66 # Fix /etc/fstab with the new volumes' UUIDs
67 if [ -e $TMPDIR/etc/fstab ]; then
68   ROOT_LINE="UUID=$root_uuid  /     ext3  defaults  0  1"
69   SWAP_LINE="UUID=$swap_uuid  swap  swap  defaults  0  0"
70   cat $TMPDIR/etc/fstab | \
71     sed -re "s#^(/dev/sda|UUID=[a-f0-9-]+)\s+/\s+.*\$#$ROOT_LINE#" \
72         -re "s#^(/dev/sdb|UUID=[a-f0-9-]+)\s+swap\s+.*\$#$SWAP_LINE#" \
73     > $TMPDIR/etc/fstab.new
74   mv $TMPDIR/etc/fstab.new  $TMPDIR/etc/fstab
75 fi
76
77 umount $TMPDIR
78 rmdir $TMPDIR
79 trap - EXIT